=== debian/changelog ===
sigx (2.0.2-5ubuntu1) wily; urgency=medium

  * Rename library packages for g++5 ABI transition.

 -- Iain Lane <iain@orangesquash.org.uk>  Tue, 04 Aug 2015 11:40:15 +0100

sigx (2.0.2-5) unstable; urgency=medium

  * [bba6d8a] Update watch file
  * [212c2eb] Add missing dependency on libjs-jquery

 -- Chow Loong Jin <hyperair@debian.org>  Sun, 24 May 2015 10:39:53 +0800

sigx (2.0.2-4) unstable; urgency=medium

  * [e9b4c01] Amend pkgconfig for multiarch lib paths (LP: #1457467)
  * [f8ecb20] Don't include DESTDIR in LIBDIR override
  * [bd9bb8f] Bump Standards-Version to 3.9.6
  * [98ee423] Don't install bundled jquery.js

 -- Chow Loong Jin <hyperair@debian.org>  Sat, 23 May 2015 02:32:47 +0800

sigx (2.0.2-3) unstable; urgency=low

  * [8fd8898] Update homepage
  * [0eecdf8] Bump Standards-Version to 3.9.4
  * [25dee45] Override LIBDIR for multiarch paths
  * [ea1e5e9] Update install files for multiarch paths
  * [ff9082e] Reexport patches using gbp-pq
  * [49b0029] Patch SConstruct to not blindly append to LIBDIR
  * [b1c5b05] Set CPPFLAGS
  * [3e2470f] Add Multi-Arch fields

 -- Chow Loong Jin <hyperair@debian.org>  Sun, 01 Sep 2013 21:59:30 +0800

sigx (2.0.2-2) experimental; urgency=low

  * [b0e5a0e] Move to 3.0 (quilt) format
  * [84b3009] Patch to avoid including individual glib headers (Closes: #665611)
  * [a8e7d0e] Bump Standard-Version to 3.9.3
  * [967938e] Update debian/copyright to fit new copyright-format
  * [aa6892c] Update my email address
  * [893a08c] Include dpkg/default.mk for build flags
  * [85c2eb5] Fix up broken SHLINKFLAGS handling in scons

 -- Chow Loong Jin <hyperair@debian.org>  Thu, 17 May 2012 13:52:31 +0800

sigx (2.0.2-1) unstable; urgency=low

  * Initial release (Closes: #492215)
  * Original .tar.bz2 tarball repackaged into .tar.gz, see debian/copyright
    and debian/rules for more details.

 -- Chow Loong Jin <hyperair@gmail.com>  Mon, 23 Mar 2009 05:19:42 +0800
