=== debian/control ===
Source: sigx
Section: devel
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Chow Loong Jin <hyperair@debian.org>
Build-Depends: debhelper (>= 7.2),
               dpkg-dev (>= 1.16.1~),
               m4,
               scons,
               doxygen,
               libsigc++-2.0-dev,
               libgtkmm-2.4-dev,
               libglibmm-2.4-dev,
               libglib2.0-dev,
               libboost-dev
Standards-Version: 3.9.6
Vcs-Git: git://git.debian.org/git/collab-maint/sigx.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/sigx.git
Homepage: http://triendl.info/sigx/

Package: libsigx-2.0-2v5
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: libsigx-2.0-2
Replaces: libsigx-2.0-2
Description: interthread communication library for C++ - runtime
 This library is an interthread communication library for C++ on top of
 libsigc++ and glibmm. It provides dispatcher based interthread communication,
 typesafe functor adaptors to execute functions in the context of another
 thread, threadsafe wrappers for signals and connections, and deadlock detection
 for synchronous messages.
 .
 This package contains the runtime files for libsigx, needed if you wish to run
 or compile software which depends on it.

Package: libsigx-2.0-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends},
         libsigx-2.0-2v5 (= ${binary:Version}),
         pkg-config,
         libsigc++-2.0-dev,
         libglibmm-2.4-dev,
         libglib2.0-dev
Suggests: libsigx-2.0-doc
Description: interthread communication for C++ - development files
 This library is an interthread communication library for C++ on top of
 libsigc++ and glibmm. It provides dispatcher based interthread communication,
 typesafe functor adaptors to execute functions in the context of another
 thread, threadsafe wrappers for signals and connections, and deadlock detection
 for synchronous messages.
 .
 This package contains the development files for libsigx, needed only if you
 wish to write or compile software which uses it. 


Package: libsigx-2.0-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}, libjs-jquery
Recommends: libsigx-2.0-dev
Description: interthread communication for C++ - reference documentation
 This library is an interthread communication library for C++ on top of
 libsigc++ and glibmm. It provides dispatcher based interthread communication,
 typesafe functor adaptors to execute functions in the context of another
 thread, threadsafe wrappers for signals and connections, and deadlock detection
 for synchronous messages.
 .
 This package contains the reference documentation for libsigx, needed only if
 you wish to write software which uses it.
