=== debian/watch ===
version=3

http://triendl.eu/sigx/ sigx-(.*)\.tar\.bz2
